#pragma once
#include "misc/singleton/singleton.h"

class dummy_audio_device;
class port_audio_device;

class audio_device_manager : public singleton_t<audio_device_manager> {
public:
    void init(singleton_initliazer& initliazer) override;
    void release() override;

    void start();

    [[nodiscard]] const char* get_name() override { return "audio_device_manager"; }

    [[nodiscard]] double get_sample_rate() const;
    void set_sample_rate(double sample_rate);
    [[nodiscard]] uint32_t get_buffer_size() const;
    void set_buffer_size(int buffer_size);
    [[nodiscard]] uint32_t get_input_channel_count() const;
    [[nodiscard]] uint32_t get_output_channel_count() const;
private:
    port_audio_device* main_audio_device_ = nullptr;
    dummy_audio_device* dummy_audio_device_ = nullptr;
};

DEFINE_SINGLETON_INSTANCE(audio_device_manager)
