#include "glfw_misc.h"

#ifdef WIN32
#define GLFW_EXPOSE_NATIVE_WIN32
#elif defined(__APPLE__)
#define GLFW_EXPOSE_NATIVE_COCOA
#else
#define GLFW_EXPOSE_NATIVE_X11
#endif
#include <GLFW/glfw3native.h>

void* glfwGetWindowHandle(GLFWwindow* window) {
#ifdef WIN32
    return glfwGetWin32Window(window);
#elif defined(__APPLE__)
    return glfwGetCocoaWindow(window);
#else
    return glfwGetX11Window(window);
#endif
}
